///////////////////////////////////////////////////////////////////////////
// bankClientImpl.java Define remote objects
// Version:     1.0
// Language:    Visual J++, ver 6,0
// Platform:    Windows NT 4.00
// Project:     CPS616 Final Project, Spring 2000
// Author:      Mehmet Akif Nacar 
// e-mail:      manacar@mailbox.syr.edu   
///////////////////////////////////////////////////////////////////////////

import java.io.*;
import java.awt.*;
import java.rmi.*;
import java.rmi.server.*;

// To define RMI serverpublic class bankClientImpl extends UnicastRemoteObject implements
bankClient {

    private myDatabase database;
    private String objName;
           
    //constructor
    public bankClientImpl(String s) throws java.rmi.RemoteException {
        super();
        objName = s;
        database = new myDatabase();
    }

   	// to use transaction method and returns the price 
    public String transfer( String acc_id, String passw, String fromNo, String toNo, String amount) throws java.rmi.RemoteException, Exception 
    {
       try{
         // call transaction method from database object via JDBC//		 return  database.transaction( computer, name, address, payment );		   return "OK";
       }
       catch (Exception e)
       {
          throw e;      
       }
    }
	// to use transaction method and returns the price 
    public String deposit( String acc_id, String passw, String acc_type, String amount) throws java.rmi.RemoteException, Exception 
    {
       try{
         // call transaction method from database object via JDBC//		 return  database.transaction( computer, name, address, payment );		   return "OK";
       }
       catch (Exception e)
       {
          throw e;      
       }
    }

		// to use transaction method and returns the price 
    public String withdraw( String acc_id, String passw, String acc_type, String amount) throws java.rmi.RemoteException, Exception 
    {
       try{
         // call transaction method from database object via JDBC//		 return  database.transaction( computer, name, address, payment );		   return "OK";
       }
       catch (Exception e)
       {
          throw e;      
       }
    }

		// to use transaction method and returns the price 
    public String balance( String acc_id, String passw, String acc_type) throws java.rmi.RemoteException, Exception 
    {
       try{
         // call transaction method from database object via JDBC//		 return  database.transaction( computer, name, address, payment );		 return "OK";  
       }
       catch (Exception e)
       {
          throw e;      
       }
    }
	
    // open the database 
    public void open() throws java.rmi.RemoteException, Exception 
    {     
       try {		   database.open();		           
       } catch (Exception e) {
           throw e;
       }
    }

    // close the database.
    public void close() throws java.rmi.RemoteException, Exception 
    {
       try {
           database.close();
       } catch (Exception e) {
           throw e;
       }
    }

  public static void main(String[] args)
  {
    // Create and install the security manager
    System.setSecurityManager(new RMISecurityManager());

    try {
          bankClientImpl obj = new bankClientImpl("bankClientServer");
          Naming.rebind("//carver.npac.syr.edu:5554/bankClientServer",obj);
          System.out.println("bankClientImpl created and bound in the registry to name bankClientServer  ");
    }
    catch (Exception ex) {
      System.err.println("bankClient Server: Exception-> " + ex);
      ex.printStackTrace();
    }
  }
}


